stages:
  - build

variables:
  DOCKER_TLS_CERTDIR: ""
  DOCKER_HOST: tcp://docker:2375/
  # When using dind, it's wise to use the overlayfs driver for
  # improved performance.
  DOCKER_DRIVER: overlay2
  CI_CUSTOM_VERSION: $CI_COMMIT_SHORT_SHA
  CI_REGISTRY_IMAGE: 9lukas5
  CI_REGISTRY_USER: 9lukas5

.docker_build_services: &docker_build_services
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - docker info

.build_template: &build_template
  script:
      - docker build -f Dockerfile -t $CI_REGISTRY_IMAGE/$IMAGE_NAME:$CI_CUSTOM_VERSION -t $CI_REGISTRY_IMAGE/$IMAGE_NAME:latest .
      - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
      - docker push $CI_REGISTRY_IMAGE/$IMAGE_NAME:$CI_CUSTOM_VERSION
      - docker push $CI_REGISTRY_IMAGE/$IMAGE_NAME:latest
      - docker logout

build master:
  stage: build
  <<: *docker_build_services
  variables:
    CI_CUSTOM_VERSION: $CI_COMMIT_SHORT_SHA
    IMAGE_NAME: plantuml
  <<: *build_template
  only:
    refs:
      - master

build tag:
  stage: build
  <<: *docker_build_services
  variables:
    CI_CUSTOM_VERSION: $CI_COMMIT_TAG
    IMAGE_NAME: plantuml
  <<: *build_template
  only:
    - tags
